#IFDEF __FB_WIN32__
#INCLUDE "windows.bi"
#ELSE
CONST FALSE=0, TRUE=NOT FALSE
#ENDIF

DECLARE SUB FONT (WORT AS STRING, HOEHE AS INTEGER, BREITE AS INTEGER, FARBE1 AS INTEGER, FARBE2 AS INTEGER, FARBE3 AS INTEGER)
DECLARE SUB WUERFELN
DECLARE SUB PRUEFEN
DECLARE SUB SPIELFELD
DECLARE SUB SIMULATION
DECLARE SUB SIMUL

DIM SHARED AS INTEGER L, T, E, XXX
DIM SHARED AS INTEGER a = 311, i, k, dran, Zufall(2), Aktion, Zeit, whandle
DIM SHARED AS INTEGER Spieler(2), Standortalt(2), Standortneu(2)

DIM SHARED AS INTEGER X(A), Y(A)

DIM SHARED AS INTEGER Wuerfelsperre, ENDE, Ausgabe, Computer, Simulieren
DIM SHARED AS INTEGER mausx, mausy, mausk

DIM f AS INTEGER = FREEFILE

RANDOMIZE TIMER

' Werte definieren
Spieler(1) = 1 ' Startfeld Spieler 1
Spieler(2) = 1 ' Startfeld Spieler 2
Zeit = 10 ' Zeit in Millisekunden fr die Simulation
Computer = TRUE ' Computer aktivieren/deaktivieren
Ausgabe = TRUE ' Infomeldung ausgeben mit einer Messagebox (WINAPI-Funktion) bei True!
Simulieren = TRUE ' Simulation aktivieren/deaktivieren

ENDE = FALSE ' Bei True zieht keine Figur mehr - Spielfigur hat das Zielfeld erreicht!



dran = INT(RND * 2) + 1 ' ermitteln wer als 1. ziehen darf


' ********************************************************************************************************


SCREENRES 750, 600, 32

/'
'	SCREEN 20, 32, 4, 1
'------ Icon in der Titelleiste ------
SCREENCONTROL 2, whandle '2 = fb.GET_WINDOW_HANDLE
SendMessage (CAST (HWND, whandle), WM_SETICON, ICON_SMALL, _
CAST( INTEGER, LoadImage ( GetModuleHandle (NULL), _
"MY_ICON", IMAGE_ICON, 0, 0, LR_COPYFROMRESOURCE  ) ) )
WINDOWTITLE "Lauf Forrest lauf"
'/


' Koordinaten der Zielfelder laden
OPEN "Koordinaten.lfl" FOR INPUT AS #f
A = 1
DO UNTIL EOF(f)
	INPUT #f, X(A), Y(A)
	A += 1
LOOP
CLOSE #f

DO

	' Computer gegen Mensch - Mensch wrfelt
	IF Computer = TRUE AND Dran = 2 THEN
		IF MULTIKEY(&h39) AND Wuerfelsperre THEN WUERFELN
	END IF

	' Mensch gegen Mensch - Mensch wrfelt!!!
	IF Computer = FALSE THEN
		IF MULTIKEY(&h39) AND Wuerfelsperre THEN WUERFELN
	END IF

	' Computer wrfelt!!!
	IF Computer = TRUE AND Dran = 1 THEN SLEEP 1: WUERFELN


	' Spielfeld laden
	SPIELFELD

	' Zeit fr Simulation anzeigen!

	SCREENLOCK
	FONT "                ", 4, 77, &hFFFFFF, &h55FFFF, &h00AAAA
	FONT "Zeit Simul: " + LTRIM$(STR$(Zeit)), 4, 77, &hFFFFFF, &h55FFFF, &h00AAAA
	FONT "PC wrfelt: " + LTRIM$(STR$(Zufall(1))), 40, 77, &hFFFFFF, &h55FFFF, &h00AAAA
	FONT "Mensch wrfelt: " + LTRIM$(STR$(Zufall(2))), 42, 77, &hFFFFFF, &h55FFFF, &h00AAAA
	FONT "                 ", 46, 77, &hFFFFFF, &h55FFFF, &h00AAAA
	FONT "PC steht: " + LTRIM$(STR$(Spieler(1))), 46, 77, &hFFFFFF, &h55FFFF, &h00AAAA
	FONT "                 ", 18, 77, &hFFFFFF, &h55FFFF, &h00AAAA
	FONT "Mensch steht: " + LTRIM$(STR$(Spieler(2))), 48, 77, &hFFFFFF, &h55FFFF, &h00AAAA
	IF Simulieren THEN FONT "Simulation ein", 8, 77, &hFFFFFF, &h55FFFF, &h00AAAA
	IF Simulieren = FALSE THEN FONT "Simulation aus", 8, 77, &hFFFFFF, &h55FFFF, &h00AAAA
	IF Ausgabe THEN FONT "Infobox ein", 10, 77, &hFFFFFF, &h55FFFF, &h00AAAA
	IF Ausgabe = FALSE THEN FONT "Infobox aus", 10, 77, &hFFFFFF, &h55FFFF, &h00AAAA
	IF Computer THEN FONT "Computer ein", 12, 77, &hFFFFFF, &h55FFFF, &h00AAAA
	IF Computer = FALSE THEN FONT "Computer aus", 12, 77, &hFFFFFF, &h55FFFF, &h00AAAA
	SCREENUNLOCK


	' Wrfeln mit der Leertaste!
	IF MULTIKEY(&h39) THEN Wuerfelsperre = FALSE ELSE IF mausk = 0 THEN Wuerfelsperre = TRUE: SLEEP 1000

	' Simultation mit - beschleunigen!
	IF MULTIKEY(&h0C) AND Zeit > 0 THEN Zeit -= 10

	' Simulation mit + verringern!
	IF MULTIKEY(&h4E) AND Zeit < 1000 THEN Zeit += 10

	' Simultation mit F11 beschleunigen!
	IF MULTIKEY(&h57) AND Zeit > 0 THEN Zeit -= 10

	' Simulation mit F12 verringern!
	IF MULTIKEY(&h58) AND Zeit < 1000 THEN Zeit += 10

	' Programm beenden mit der ESC-Taste!
	IF MULTIKEY(&h01) THEN END

	IF ENDE THEN EXIT DO

LOOP

' Anzeigen wer gewonnen hat!
#IFDEF __FB_WIN32__
IF Spieler(1) = 311 THEN MessageBox(0, "Computer hat gewonnen!", "Lauf Forrest lauf", MB_ICONINFORMATION OR MB_SYSTEMMODAL)
IF Spieler(2) = 311 THEN MessageBox(0, "Mensch hat gewonnen!", "Lauf Forrest lauf", MB_ICONINFORMATION OR MB_SYSTEMMODAL)
#ELSE
IF Spieler(1) = 311 THEN LOCATE 5,5: PRINT "Computer hat gewonnen!"
IF Spieler(2) = 311 THEN LOCATE 5,5: PRINT "Mensch hat gewonnen!"
LOCATE 9,5: PRINT "Weiter mit beliebiger Taste!"
SLEEP
#ENDIF

' 311 Felder sind es insgesamt
'
' Feld 1:  Startfeld
' Feld 6: -3
' Feld 11: +5
' Feld 21: -3
' Feld 35: zurck zum Startfeld
' Feld 42: +5
' Feld 67: ?-Feld
' Feld 81: gehe zu Feld 101
' Feld 117: gehe zu Feld 187
' Feld 130: +5
' Feld 142: gehe zu Feld 32
' Feld 147: zurck zum Startfeld
' Feld 165: zurck zum Startfeld
' Feld 182: gehe zu Feld 252
' Feld 200: -3
' Feld 217: gehe zu Feld 95
' Feld 260: gehe zu Feld 190
' Feld 271: ?-Feld
' Feld 277: zurck zum Startfeld
' Feld 291: +5
' Feld 299: -3
' Feld 304: ?-Feld
' Feld 309: Gehe zu Feld 227
' Feld 311: Zielfeld

END

SUB WUERFELN

	Wuerfelsperre = FALSE

	' Zufallszahl ermitteln
	Zufall(Dran) = INT(RND * 6) + 1

	' Standort (alt) speichern
	Standortalt(dran) = Spieler(dran)

	' Standort errechnen
	IF ENDE = FALSE THEN Spieler(dran) += Zufall(Dran)

	' Standort (neu) speichern
	Standortneu(dran) = Spieler(dran)

	' Spielfigur auf dem Feld stehen lassen, wenn die Wrfelzahl zuviel fr das Zielfeld ist!
	IF Spieler(dran) > 311 THEN Spieler(dran) = Standortalt(dran)

	' erreicht eine Figur das Zielfeld, ist das Spiel vorbei! (Ende wird auf True gesetzt)
	IF Spieler(dran) = 311 THEN ENDE = TRUE

	' auf Aktionsfeld prfen
	PRUEFEN

	' anderer Spieler ist an der Reihe
	dran += 1
	IF dran > 2 THEN dran = 1

END SUB


SUB PRUEFEN

	' Zufallszahl ermitteln fr Aktion
	IF (SPIELER(dran) = 67) OR (SPIELER(dran) = 271) OR (SPIELER(dran) = 304) THEN
		Aktion = INT(RND * 4) + 1
	ELSE
		Aktion = 0
	END IF

	IF SPIELER(dran) = 6 THEN Aktion = 2: SPIELFELD: SPIELER(dran) = 3
	IF SPIELER(dran) = 11 THEN Aktion = 3: SPIELFELD: SPIELER(dran) =  16
	IF SPIELER(dran) = 21 THEN Aktion = 2: SPIELFELD: SPIELER(dran) = 18
	IF SPIELER(dran) = 35 THEN Aktion = 1: SPIELFELD: SPIELER(dran) =  1
	IF SPIELER(dran) = 42 THEN Aktion = 3: SPIELFELD: SPIELER(dran) =  47
	IF SPIELER(dran) = 67 AND Aktion = 1 THEN SPIELFELD: SPIELER(dran) =  1 ' Startfeld
	IF SPIELER(dran) = 67 AND Aktion = 2 THEN SPIELFELD: SPIELER(dran) =  64 ' -3
	IF SPIELER(dran) = 67 AND Aktion = 3 THEN SPIELFELD: SPIELER(dran) =  72 ' +5
	IF SPIELER(dran) = 67 AND Aktion = 4 THEN SPIELFELD: SPIELER(dran) =  67 ' +/- 0
	IF SPIELER(dran) = 81 THEN Aktion = 5: SPIELFELD: SPIELER(dran) = 101
	IF SPIELER(dran) = 117 THEN Aktion = 5: SPIELFELD: SPIELER(dran) =  187
	IF SPIELER(dran) = 130 THEN Aktion = 3: SPIELFELD: SPIELER(dran) =  135
	IF SPIELER(dran) = 142 THEN Aktion = 6: SPIELFELD: SPIELER(dran) =  32
	IF SPIELER(dran) = 147 THEN Aktion = 1: SPIELFELD: SPIELER(dran) =  1
	IF SPIELER(dran) = 165 THEN Aktion = 1: SPIELFELD: SPIELER(dran) =  1
	IF SPIELER(dran) = 182 THEN Aktion = 5: SPIELFELD: SPIELER(dran) =  252
	IF SPIELER(dran) = 200 THEN Aktion = 2: SPIELFELD: SPIELER(dran) =  197
	IF SPIELER(dran) = 217 THEN Aktion = 6: SPIELFELD: SPIELER(dran) =  95
	IF SPIELER(dran) = 260 THEN Aktion = 6: SPIELFELD: SPIELER(dran) =  190
	IF SPIELER(dran) = 271 AND Aktion = 1 THEN SPIELFELD: SPIELER(dran) =  1 ' Startfeld
	IF SPIELER(dran) = 271 AND Aktion = 2 THEN SPIELFELD: SPIELER(dran) =  268 ' -3
	IF SPIELER(dran) = 271 AND Aktion = 3 THEN SPIELFELD: SPIELER(dran) =  276 ' +5
	IF SPIELER(dran) = 271 AND Aktion = 4 THEN SPIELFELD: SPIELER(dran) =  271 ' +/- 0
	IF SPIELER(dran) = 277 THEN Aktion = 1: SPIELFELD: SPIELER(dran) =  1
	IF SPIELER(dran) = 291 THEN Aktion = 3: SPIELFELD: SPIELER(dran) =  296
	IF SPIELER(dran) = 299 THEN Aktion = 2: SPIELFELD: SPIELER(dran) =  296
	IF SPIELER(dran) = 304 AND Aktion = 1 THEN SPIELFELD: SPIELER(dran) =  1 ' Startfeld
	IF SPIELER(dran) = 304 AND Aktion = 2 THEN SPIELFELD: SPIELER(dran) =  301 ' -3
	IF SPIELER(dran) = 304 AND Aktion = 3 THEN SPIELFELD: SPIELER(dran) =  309 ' +5
	IF SPIELER(dran) = 304 AND Aktion = 4 THEN SPIELFELD: SPIELER(dran) =  304 ' +/- 0
	IF SPIELER(dran) = 309 THEN Aktion = 6: SPIELFELD: SPIELER(dran) =  227

	#IFDEF __FB_WIN32__
	IF Ausgabe THEN
		IF Aktion = 1 THEN MessageBox(0, "gehe zurck zum Startfeld!", "Lauf Forrest lauf", MB_ICONINFORMATION OR MB_SYSTEMMODAL)
		IF Aktion = 2 THEN MessageBox(0, "gehe 3 Felder zurck!", "Lauf Forrest lauf", MB_ICONINFORMATION OR MB_SYSTEMMODAL)
		IF Aktion = 3 THEN MessageBox(0, "gehe 5 Felder vor!", "Lauf Forrest lauf", MB_ICONINFORMATION OR MB_SYSTEMMODAL)
		IF Aktion = 4 THEN MessageBox(0, "Glck gehabt! Nichts passiert!", "Lauf Forrest lauf", MB_ICONINFORMATION OR MB_SYSTEMMODAL)
		IF Aktion = 5 THEN MessageBox(0, "Glckspilz! Es geht nach oben!", "Lauf Forrest lauf", MB_ICONINFORMATION OR MB_SYSTEMMODAL)
		IF Aktion = 6 THEN MessageBox(0, "Pech gehabt! Es geht nach unten!", "Lauf Forrest lauf", MB_ICONINFORMATION OR MB_SYSTEMMODAL)
	END IF
	#ENDIF


	IF Aktion > 0 AND Simulieren THEN SIMULATION

	Aktion = 0

END SUB


SUB SPIELFELD

	SCREENLOCK ' Bildschirm sperren

	' Menu anzeigen!
	DIM AS ANY PTR Menupuffer
	Menupuffer = IMAGECREATE(600,600)
	BLOAD (EXEPATH & "\Menu_Gro_16bit_neu.bmp", Menupuffer)
	PUT (1,1), Menupuffer, PSET
	IMAGEDESTROY(Menupuffer)

	' Spieler 1 anzeigen!
	DIM AS ANY PTR Spieler1puffer
	Spieler1puffer = IMAGECREATE(17,17)
	BLOAD (EXEPATH & "\Spieler 2_17.bmp", Spieler1puffer)
	PUT (X(Spieler(1)),Y(Spieler(1))), Spieler1puffer, TRANS
	IMAGEDESTROY(Spieler1puffer)

	' Spieler 2 anzeigen!
	DIM AS ANY PTR Spieler2puffer
	Spieler2puffer = IMAGECREATE(17,17)
	BLOAD (EXEPATH & "\Spieler 1_17.bmp", Spieler2puffer)
	PUT (X(Spieler(2)),Y(Spieler(2))), Spieler2puffer, TRANS
	IMAGEDESTROY(Spieler2puffer)

	SCREENUNLOCK ' Bildschirm freigeben

END SUB

SUB Simulation

	' Werte fr Simulation errechnen!
	IF Aktion = 1 THEN i = Standortneu(dran) - Spieler(dran)' runter
	IF Aktion = 2 THEN i = Standortneu(dran) - Spieler(dran)' runter
	IF Aktion = 3 THEN i = Spieler(dran) - Standortneu(dran)' rauf
	IF Aktion = 4 THEN i = 0
	IF Aktion = 5 THEN i = Spieler(dran) - Standortneu(dran)' rauf
	IF Aktion = 6 THEN i = Standortneu(dran) - Spieler(dran)' runter

	DO

		SCREENLOCK ' Bildschirm sperren

		' Menu anzeigen!
		DIM AS ANY PTR Menupuffer
		Menupuffer = IMAGECREATE(600,600)
		BLOAD (EXEPATH & "\Menu_Gro_16bit_neu.bmp", Menupuffer)
		PUT (1,1), Menupuffer, PSET
		IMAGEDESTROY(Menupuffer)

		' Spieler 1 anzeigen!
		DIM AS ANY PTR Spieler1puffer
		Spieler1puffer = IMAGECREATE(17,17)
		BLOAD (EXEPATH & "\Spieler 2_17.bmp", Spieler1puffer)
		IF Dran = 1 THEN
			IF Aktion = 1 THEN PUT (X(Spieler(1)+i), Y(Spieler(1)+i)), Spieler1puffer, TRANS
			IF Aktion = 2 THEN PUT (X(Spieler(1)+i), Y(Spieler(1)+i)), Spieler1puffer, TRANS
			IF Aktion = 3 THEN PUT (X(Spieler(1)-i), Y(Spieler(1)-i)), Spieler1puffer, TRANS
			IF Aktion = 4 THEN PUT (X(Spieler(1)-i), Y(Spieler(1)-i)), Spieler1puffer, TRANS
			IF Aktion = 5 THEN PUT (X(Spieler(1)-i), Y(Spieler(1)-i)), Spieler1puffer, TRANS
			IF Aktion = 6 THEN PUT (X(Spieler(1)+i), Y(Spieler(1)+i)), Spieler1puffer, TRANS
		END IF
		IF Dran = 2 THEN PUT (X(Spieler(1)), Y(Spieler(1))), Spieler1puffer, TRANS
		IMAGEDESTROY(Spieler1puffer)

		' Spieler 2 anzeigen!
		DIM AS ANY PTR Spieler2puffer
		Spieler2puffer = IMAGECREATE(17,17)
		BLOAD (EXEPATH & "\Spieler 1_17.bmp", Spieler2puffer)
		IF Dran = 2 THEN
			IF Aktion = 1 THEN PUT (X(Spieler(2)+i), Y(Spieler(2)+i)), Spieler2puffer, TRANS
			IF Aktion = 2 THEN PUT (X(Spieler(2)+i), Y(Spieler(2)+i)), Spieler2puffer, TRANS
			IF Aktion = 3 THEN PUT (X(Spieler(2)-i), Y(Spieler(2)-i)), Spieler2puffer, TRANS
			IF Aktion = 4 THEN PUT (X(Spieler(2)-i), Y(Spieler(2)-i)), Spieler2puffer, TRANS
			IF Aktion = 5 THEN PUT (X(Spieler(2)-i), Y(Spieler(2)-i)), Spieler2puffer, TRANS
			IF Aktion = 6 THEN PUT (X(Spieler(2)+i), Y(Spieler(2)+i)), Spieler2puffer, TRANS
		END IF
		IF Dran = 1 THEN PUT (X(Spieler(2)), Y(Spieler(2))), Spieler2puffer, TRANS
		IMAGEDESTROY(Spieler2puffer)

		' Bildschirm freigeben
		SCREENUNLOCK

		' Zhler i runterzhlen
		i -= 1

		' Schleife verlassen, wenn die Figur auf ihrem Zielfeld gelandet ist!
		IF i < 1 THEN EXIT DO

		' warten wegen Simulation
		SLEEP Zeit, 1

	LOOP

	' warten wegen Simulation
	SLEEP Zeit, 1



END SUB

SUB FONT (WORT AS STRING, HOEHE AS INTEGER, BREITE AS INTEGER, FARBE1 AS INTEGER, FARBE2 AS INTEGER, FARBE3 AS INTEGER)

	'
	REM PALETTE 7, 7
	COLOR 7
	L = LEN(WORT)

	CharToOem Wort, Wort

	LOCATE HOEHE, BREITE: PRINT WORT;
	T = HOEHE * 8 - 8
	FOR E = BREITE * 8 - 8 TO BREITE * 8 + L * 8 - 8
		FOR XXX = 0 TO 7
			IF XXX < 2 AND POINT(E, T + XXX) = 7 THEN PSET (E, T + XXX), FARBE1
			IF XXX > 1 AND XXX < 5 AND POINT(E, T + XXX) = 7 THEN PSET (E, T + XXX), FARBE2
			IF XXX > 4 AND POINT(E, T + XXX) = 7 THEN PSET (E, T + XXX), FARBE3
		NEXT
	NEXT
	PALETTE
	COLOR 15
END SUB